%define mesaver 	CVS
%define mesadate	20010208

Name:		Mesa
Summary: A 3-D graphics library similar to OpenGL.
Version:	3.4
Release:	13
Epoch:		2
Copyright:	GPL/XFree86
Group: System Environment/Libraries
Requires:	XFree86 >= 3.3.3
BuildRoot:	%{_tmppath}/%{name}-root
Source:		ftp://ftp.mesa3d.org/mesa/beta/Mesa-%{version}-%{mesadate}.tar.bz2
Source2:        XFree86-4.0.3-1-GLonly.tar.bz2
# Create Source2 from XFree86 using
# tar Icf XFree86-4.0.2-10-GLonly.tar.bz2 xc/include/extensions/extutil.h \
#     xc/include/GL xc/lib/GL \
#     xc/programs/Xserver/hw/xfree86/os-support/xf86drm* \
#     xc/programs/Xserver/GL/dri/*.h
Patch1:		Mesa-XF86DRI-4.0.2.patch
Patch4:		Mesa-3.4-badlibtool.patch
Patch5:		Mesa-3.3-glibc22.patch
Patch6:		Mesa-3.3-glXcontext.patch
Patch7:		Mesa-3.4-nopthread.patch
Conflicts:	glxMesa-mga, glxMesa-tnt, glxMesa-mach64
Obsoletes:	glxMesa
URL:		http://www.mesa3d.org
Prefix:		%{_prefix}

%description
The Mesa 3-D graphics library is a powerful and generic toolset for
creating hardware assisted computer graphics.  To the extent that Mesa
utilizes the OpenGL command syntax or state machine, it is being used
with authorization from Silicon Graphics, Inc.  However, the author
(Brian Paul) makes no claim that Mesa is in any way a compatible
replacement for OpenGL or associated with Silicon Graphics, Inc. Those
who want a licensed implementation of OpenGL should contact a licensed
vendor.  However, Mesa is very similar to OpenGL, and you might find
Mesa to be a valid alternative to OpenGL.

%package devel
Summary: Development files for the Mesa 3-D graphics library.
Group: Development/Libraries
Requires: Mesa = %{version}-%{release}
Obsoletes: glxMesa-devel

%description devel
Mesa-devel contains the static version of the Mesa 3-D graphics
library (a graphics toolkit very similar to Silicon Graphics' OpenGL
graphics utilities toolkit) and includes files needed for development.
If you're going to develop Mesa applications, you'll need to install
mesa-devel. If you're just going to use Mesa, you don't need to
install mesa-devel.

%package demos
Summary: Demos for the Mesa 3D graphics library.
Group: Applications/Multimedia
Requires: Mesa = %{version}-%{release}

%description demos
Some sample applications using the Mesa 3D graphics library.

%prep
%setup -q
find . -type d -name CVS |xargs rm -rf
mkdir -p src/DRI/GL
bzcat %{SOURCE2} |tar xf -
ln -f `find xc -type f` src/DRI
mv -f src/DRI/glxmd.h src/DRI/GL/glxmd.h
%patch1 -p1 -b .xf86dri
%patch4 -p1 -b .libtool
%patch5 -p1 -b .glibc22
%patch6 -p1 -b .context
%patch7 -p1 -b .nopthread

# First of all, fix up the demos
perl -pi -e "s,\.\./images/,%{prefix}/share/Mesa-demos/images/,g" demos/*

%build
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
  numprocs=1
fi
  
aclocal -I .
autoheader
automake -a -c || :
autoconf
%{__cp} /usr/share/libtool/config.* .
%{__cp} /usr/share/libtool/config.* widgets-mesa/
%ifarch i386 i486 i586 i686
CONFIGFLAGS="--enable-x86 --enable-mmx --enable-katmai"
%else
CONFIGFLAGS="--disable-mmx --disable-3dnow --disable-katmai"
%endif
CFLAGS="$RPM_OPT_FLAGS -DNDEBUG" CXXFLAGS="$RPM_OPT_FLAGS -DNDEBUG" ./configure --enable-optimize --without-svga \
	--prefix=%{prefix} --sysconfdir=%{_sysconfdir} $CONFIGFLAGS \
	--enable-shared --enable-static --without-ggi --without-glide

%ifnarch s390x
make -j$numprocs
%else
make
%endif

%install
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
  numprocs=1
fi
 
mkdir -p $RPM_BUILD_ROOT%{prefix}/share/Mesa-demos/src
mkdir -p $RPM_BUILD_ROOT%{prefix}/bin
make install prefix=$RPM_BUILD_ROOT/%{_prefix} \
	sysconfdir=$RPM_BUILD_ROOT/%{_sysconfdir}

cp -aR images $RPM_BUILD_ROOT%{prefix}/share/Mesa-demos/
for i in demos xdemos book; do
  cp -aR $i $RPM_BUILD_ROOT%{prefix}/share/Mesa-demos/src
  cd $i
  make -j$numprocs check || :
  for j in *; do
    [ -x $j ] && cp -aR $j $RPM_BUILD_ROOT%{prefix}/bin
  done
  cd ..
done

for i in image hello; do
	mv $RPM_BUILD_ROOT%{prefix}/bin/$i $RPM_BUILD_ROOT%{prefix}/bin/Mesa$i
done

%files 
%defattr(-,root,root)
%doc docs/CONFIG docs/CONFORM docs/COPYRIGHT docs/README docs/README.MITS
%doc docs/README.X11 docs/VERSIONS docs/RELNOTES*
%config %{_sysconfdir}/mesa.conf
%{prefix}/%{_lib}/lib*.so.*

%files devel
%defattr(-,root,root)
%doc docs/DEVINFO docs/*.spec docs/README.THREADS
%{prefix}/include/GL
%{prefix}/%{_lib}/lib*.so
%{prefix}/%{_lib}/lib*.a
%{prefix}/%{_lib}/lib*.la

%files demos
%defattr(-,root,root)
%{prefix}/bin/*
%{prefix}/share/Mesa-demos

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat Mar 16 2001 Mike A. Harris <mharris@redhat.com> 3.4-13
- Updated Mesa for XFree86 release 4.0.3-1

* Thu Mar 15 2001 Mike A. Harris <mharris@redhat.com> 3.4-12
- Updated Mesa for XFree86 release 4.0.2a-1

* Fri Mar  9 2001 Mike A. Harris <mharris@redhat.com>
- Fixed specfile to use bzcat to remove dependancy on "tar -j"
- Corrected the specfile to properly use XFree86-4.0.2-12 not -10

* Fri Mar  9 2001 Mike A. Harris <mharris@redhat.com>
- Sync up with XFree86-4.0.2-12
- Build release Mesa-3.4-10

* Tue Feb 27 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Sync with XFree86 4.0.2-10
- Rename demos (#25687)

* Fri Feb  9 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Define numprocs in %%install stage (#26839)

* Thu Feb  8 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Sync DRI with XFree86
- Fix up glXGetCurrentContext() again... (Bug #18867)

* Tue Feb  6 2001 Jakub Jelinek <jakub@redhat.com>
- don't link libGL against -lpthread

* Tue Jan 16 2001 Than Ngo <than@redhat.com>
- fixed to build on s390
- don't use make -jCPU on s390, it's broken

* Mon Jan  8 2001 Bill Nottingham <notting@redhat.com>
- explicitly disable glide (our glide is just a DRI client...)

* Mon Jan  8 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update DRI (Patch from katzj@linuxpower.org) (#22578)

* Wed Dec  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update CVS
- Fix up the XF86DIR patch, problem pointed out by
  Karsten Weiss <knweiss@gmx.de>

* Mon Nov 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.4 (actually, 3.4_branch in CVS)
- ship docs
- add Mesa-demos package, we need some tests...

* Wed Oct 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up glut.h (Another prototype that doesn't match glibc 2.2's)
- Update to Mesa 3.3-RELEASE
- Fix up glXGetCurrentContext() (Bug #18867)

* Sat Sep 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Don't declare exit() in glut.h (conflicts with stdlib.h, and the
  declaration is different for C++). (Bug #17579)

* Wed Aug  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- compile with -DNDEBUG - Harald reports Quake won't do without it, for
  whatever reason.

* Wed Aug  2 2000 Bill Nottingham <notting@redhat.com>
- fix broken ia64 libs

* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- add missing glext.h (Bug #14726)

* Tue Jul 18 2000 Bill Nottingham <notting@redhat.com>
- defattr
- merge in Elliot's changes from the never-built XFree86 package
- except for the soname changes

* Wed Jul 12 2000 Jakub Jelinek <jakub@redhat.com>
- resurrect Mesa package, patch it so that it uses XF86DRI
  if available

* Thu Feb  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild in new environment

* Wed Feb 02 2000 Bill Nottingham <notting@redhat.com>
- add %post, %postun

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix stupid release numbers (use real numbers, people!)
- rebuild to fix up decsriptions and group

* Thu Jan 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up the breakage caused by yesterday's changes
- split soure RPM into software and hardware-related parts.

* Wed Jan 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Build support for all chipsets (including non-accelerated)
  no i810 support for now - that would require kernel changes.

* Tue Jan 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- New snapshot (20000111), adding support for the
  i810 chipset and fixing up ATI.

* Mon Dec 20 1999 Bill Nottingham <notting@redhat.com>
- fix build so it doesn't set -march needlessly

* Wed Dec 15 1999 Bill Nottingham <notting@redhat.com>
- fix sparc

* Tue Dec 14 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on non-x86 platforms
- Split in glxMesa and glxMesa-devel
- add download location to Source: fields
- handle RPM_OPT_FLAGS

* Fri Dec 03 1999 Preston Brown <pbrown@redhat.com>
- adopted for Red Hat Linux, changed glx.conf installation directory

* Sat Oct 23 1999 Ryan Drake <rdrake@matrox.com>
- Removed --without-mmx-asm

* Thu Jun 17 1999 Ryan Skadberg <skadz@mindstorm.com>
- Updated to Mesa3.1beta2
- Used configure script, so we get 3DNow support if available

* Mon May 31 1999 Ian Pilcher <pilcher@concentric.net>
- Added %post & %preun scripts, telling the user to edit XF86Config

* Mon May 24 1999 Ian Pilcher <pilcher@concentric.net>
- Created SPEC file template for scripted builds

* Mon May 24 1999 Ian Pilcher <pilcher@concentric.net>
- XFree86 headers now included in GLX tree; useful SRPM now possible
- package release no longer reflects Red Hat version

* Wed May 19 1999 Ian Pilcher <pilcher@concentric.net>
- fixed problem of sed reading & writing Config simultaneously

* Tue May 18 1999 Ian Pilcher <pilcher@concentric.net>
- initial SPEC file; doesn't do anything fancy

